Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | File Members

# WindowsPipeSource Class Reference

`#include <winpipes.h>`

Inheritance diagram for WindowsPipeSource:

List of all members.

## Detailed Description

Windows Pipe Source.

Definition at line 104 of file winpipes.h.

## Public Member Functions
| WindowsPipeSource (HANDLE h=INVALID_HANDLE_VALUE, bool pumpAll=false, BufferedTransformation *attachment=NULL)
bool | GetOwnership () const
void | SetOwnership (bool own)
| operator HANDLE ()
bool | HandleValid () const
void | AttachHandle (HANDLE h, bool own=false)
HANDLE | DetachHandle ()
void | CloseHandle ()
unsigned int | GetMaxWaitObjectCount () const
| maximum number of wait objects that this object can return
void | GetWaitObjects (WaitObjectContainer &container)
| put wait objects into container
unsigned int | GeneralPump2 (unsigned long &byteCount, bool blockingOutput=true, unsigned long maxTime=INFINITE_TIME, bool checkDelimiter=false, byte delimiter='\n')
| pump up to maxSize bytes using at most maxTime milliseconds
bool | SourceExhausted () const
void | SetAutoSignalPropagation (int propagation)
| set propagation of automatically generated and transferred signals
int | GetAutoSignalPropagation () const
unsigned long | Pump (unsigned long pumpMax=ULONG_MAX)
unsigned int | PumpMessages (unsigned int count=UINT_MAX)
void | PumpAll ()
virtual unsigned int | PumpAll2 (bool blocking=true)
unsigned int | Put2 (const byte *begin, unsigned int length, int messageEnd, bool blocking)
| input multiple bytes for blocking or non-blocking processing
bool | IsolatedFlush (bool, bool)
bool | IsolatedMessageSeriesEnd (bool)
unsigned int | ChannelPut2 (const std::string &channel, const byte *begin, unsigned int length, int messageEnd, bool blocking)
bool | ChannelMessageSeriesEnd (const std::string &, int, bool)
bool | Attachable ()
| returns whether this object allows attachment
BufferedTransformation * | AttachedTransformation ()
| returns the object immediately attached to this object or NULL for no attachment
const BufferedTransformation * | AttachedTransformation () const
void | Detach (BufferedTransformation *newAttachment=NULL)
| delete the current attachment chain and replace it with newAttachment
unsigned int | TransferTo2 (BufferedTransformation &target, unsigned long &transferBytes, const std::string &channel=NULL_CHANNEL, bool blocking=true)
unsigned int | CopyRangeTo2 (BufferedTransformation &target, unsigned long &begin, unsigned long end=ULONG_MAX, const std::string &channel=NULL_CHANNEL, bool blocking=true) const
void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| initialize or reinitialize this object
bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| flush buffered input and/or output
bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| mark end of a series of messages
BufferedTransformation & | Ref ()
| return a reference to this object
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
bool | Wait (unsigned long milliseconds)
| wait on this object
bool | MustWaitForResult ()
bool | Receive (byte *buf, unsigned int bufLen)
| receive data from network source, returns whether result is immediately available
unsigned int | GetReceiveResult ()
bool | EofReceived () const
unsigned int | GetMaxWaitObjectCount () const
| maximum number of wait objects that this object can return
void | GetWaitObjects (WaitObjectContainer &container)
| put wait objects into container
virtual bool | MustWaitToReceive ()
bool | Wait (unsigned long milliseconds)
| wait on this object
SIGNALS
virtual void | IsolatedInitialize (const NameValuePairs &parameters)
NONBLOCKING SOURCE
unsigned long | GeneralPump (unsigned long maxSize=ULONG_MAX, unsigned long maxTime=INFINITE_TIME, bool checkDelimiter=false, byte delimiter='\n')
unsigned long | TimedPump (unsigned long maxTime)
unsigned long | PumpLine (byte delimiter='\n', unsigned long maxSize=1024)
unsigned int | Pump2 (unsigned long &byteCount, bool blocking=true)
unsigned int | PumpMessages2 (unsigned int &messageCount, bool blocking=true)
SIGNALS
virtual void | IsolatedInitialize (const NameValuePairs &parameters)
SIGNALS
virtual void | IsolatedInitialize (const NameValuePairs &parameters)
NONBLOCKING SOURCE
unsigned long | GeneralPump (unsigned long maxSize=ULONG_MAX, unsigned long maxTime=INFINITE_TIME, bool checkDelimiter=false, byte delimiter='\n')
unsigned long | TimedPump (unsigned long maxTime)
unsigned long | PumpLine (byte delimiter='\n', unsigned long maxSize=1024)
unsigned int | Pump2 (unsigned long &byteCount, bool blocking=true)
unsigned int | PumpMessages2 (unsigned int &messageCount, bool blocking=true)
SIGNALS
virtual void | IsolatedInitialize (const NameValuePairs &parameters)
NONBLOCKING SOURCE
unsigned long | GeneralPump (unsigned long maxSize=ULONG_MAX, unsigned long maxTime=INFINITE_TIME, bool checkDelimiter=false, byte delimiter='\n')
unsigned long | TimedPump (unsigned long maxTime)
unsigned long | PumpLine (byte delimiter='\n', unsigned long maxSize=1024)
unsigned int | Pump2 (unsigned long &byteCount, bool blocking=true)
unsigned int | PumpMessages2 (unsigned int &messageCount, bool blocking=true)
SIGNALS
virtual void | IsolatedInitialize (const NameValuePairs &parameters)
## Static Public Attributes
const std::string | NULL_CHANNEL
## Protected Member Functions
virtual void | HandleChanged ()
const NetworkReceiver & | GetReceiver () const
void | SourceInitialize (bool pumpAll, const NameValuePairs &parameters)
virtual BufferedTransformation * | NewDefaultAttachment () const
void | Insert (Filter *nextFilter)
virtual bool | ShouldPropagateMessageEnd () const
virtual bool | ShouldPropagateMessageSeriesEnd () const
void | PropagateInitialize (const NameValuePairs &parameters, int propagation)
unsigned int | Output (int outputSite, const byte *inString, unsigned int length, int messageEnd, bool blocking, const std::string &channel=NULL_CHANNEL)
unsigned int | OutputModifiable (int outputSite, byte *inString, unsigned int length, int messageEnd, bool blocking, const std::string &channel=NULL_CHANNEL)
bool | OutputMessageEnd (int outputSite, int propagation, bool blocking, const std::string &channel=NULL_CHANNEL)
bool | OutputFlush (int outputSite, bool hardFlush, int propagation, bool blocking, const std::string &channel=NULL_CHANNEL)
bool | OutputMessageSeriesEnd (int outputSite, int propagation, bool blocking, const std::string &channel=NULL_CHANNEL)
virtual void | HandleError (const char *operation) const
void | CheckAndHandleError (const char *operation, BOOL result) const
## Static Protected Member Functions
int | DecrementPropagation (int propagation)
## Protected Attributes
HANDLE | m_h
bool | m_own
unsigned int | m_inputPosition
int | m_continueAt

## Member Function Documentation

unsigned int NetworkSource::GeneralPump2 | ( | unsigned long & | byteCount,
|  | bool | blockingOutput = `true`,
|  | unsigned long | maxTime = `INFINITE_TIME`,
|  | bool | checkDelimiter = `false`,
|  | byte | delimiter = `'\n'`
| ) | `[virtual, inherited]`

| pump up to maxSize bytes using at most maxTime milliseconds If checkDelimiter is true, pump up to delimiter, which itself is not extracted or pumped. Implements NonblockingSource. Definition at line 57 of file network.cpp. References Filter::AttachedTransformation(), TimerBase::ElapsedTime(), NetworkReceiver::EofReceived(), NetworkReceiver::GetReceiveResult(), INFINITE_TIME, NetworkReceiver::MustWaitForResult(), NetworkReceiver::MustWaitToReceive(), NetworkReceiver::Receive(), SecBlock< T, A >::size(), and Waitable::Wait().

void AutoSignaling< Source >::SetAutoSignalPropagation | ( | int | propagation | ) | `[inline, virtual, inherited]`

| Reimplemented from BufferedTransformation. Definition at line 168 of file simple.h.

unsigned int InputRejecting< Filter >::Put2 | ( | const byte * | begin,
|  | unsigned int | length,
|  | int | messageEnd,
|  | bool | blocking
| ) | `[inline, virtual, inherited]`

| Implements BufferedTransformation. Definition at line 99 of file simple.h.

bool Filter::Attachable | ( |  | ) | `[inline, virtual, inherited]`

| returns whether this object allows attachment Some BufferedTransformation objects (e.g. Filter objects) allow other BufferedTransformation objects to be attached. When this is done, the first object instead of buffering its output, sents that output to the attached object as input. The entire attachment chain is deleted when the anchor object is destructed. Reimplemented from BufferedTransformation. Definition at line 19 of file filters.h.

bool Filter::Flush | ( | bool | hardFlush,
|  | int | propagation = `-1`,
|  | bool | blocking = `true`
| ) | `[virtual, inherited]`

  | flush buffered input and/or output Parameters:
  | hardFlush | is used to indicate whether all data should be flushed
Note: Hard flushes must be used with care. It means try to process and output everything, even if there may not be enough data to complete the action. For example, hard flushing a HexDecoder would cause an error if you do it after inputing an odd number of hex encoded characters. For some types of filters, for example ZlibDecompressor, hard flushes can only be done at "synchronization points". These synchronization points are positions in the data stream that are created by hard flushes on the corresponding reverse filters, in this example ZlibCompressor. This is useful when zlib compressed data is moved across a network in packets and compression state is preserved across packets, as in the ssh2 protocol. Reimplemented from BufferedTransformation. Reimplemented in SecretSharing, and InformationDispersal. Definition at line 68 of file filters.cpp.

bool Filter::MessageSeriesEnd | ( | int | propagation = `-1`,
|  | bool | blocking = `true`
| ) | `[virtual, inherited]`

| mark end of a series of messages There should be a MessageEnd immediately before MessageSeriesEnd. Reimplemented from BufferedTransformation. Definition at line 82 of file filters.cpp.

BufferedTransformation& BufferedTransformation::Ref | ( |  | ) | `[inline, inherited]`

| return a reference to this object This function is useful for passing a temporary BufferedTransformation object to a function that takes a non-const reference. Definition at line 711 of file cryptlib.h.

virtual byte* BufferedTransformation::CreatePutSpace | ( | unsigned int & | size | ) | `[inline, virtual, inherited]`

| request space which can be written into by the caller, and then used as input to Put() Note: The purpose of this method is to help avoid doing extra memory allocations. Reimplemented in MeterFilter, HashFilter, Redirector, ArraySink, ArrayXorSink, and ByteQueue. Definition at line 730 of file cryptlib.h. Referenced by ArrayXorSink::CreatePutSpace().

virtual unsigned int BufferedTransformation::PutModifiable2 | ( | byte * | inString,
|  | unsigned int | length,
|  | int | messageEnd,
|  | bool | blocking
| ) | `[inline, virtual, inherited]`

  | input multiple bytes that may be modified by callee for blocking or non-blocking processing Parameters:
  | messageEnd | means how many filters to signal MessageEnd to, including this one
Reimplemented in MeterFilter, and FilterWithBufferedInput. Definition at line 748 of file cryptlib.h.

unsigned long BufferedTransformation::MaxRetrievable | ( |  | ) | const`[virtual, inherited]`

| returns number of bytes that is currently ready for retrieval All retrieval functions return the actual number of bytes retrieved, which is the lesser of the request number and MaxRetrievable(). Reimplemented in FileStore, RandomNumberStore, NullStore, MessageQueue, ByteQueue, and RandomPool. Definition at line 247 of file cryptlib.cpp. References BufferedTransformation::AttachedTransformation(), and BufferedTransformation::CopyTo(). Referenced by RandomNumberStore::AnyRetrievable(), and Integer::BERDecode().

bool BufferedTransformation::GetNextMessage | ( |  | ) | `[virtual, inherited]`

| start retrieving the next message Returns false if no more messages exist or this message is not completely retrieved. Reimplemented in MessageQueue, and Store. Definition at line 336 of file cryptlib.cpp. References BufferedTransformation::AnyMessages(), and BufferedTransformation::AttachedTransformation().

bool Waitable::Wait | ( | unsigned long | milliseconds | ) | `[inherited]`

| wait on this object same as creating an empty container, calling GetWaitObjects(), and calling Wait() on the container Definition at line 321 of file wait.cpp. References Waitable::GetWaitObjects(), and WaitObjectContainer::Wait(). Referenced by NetworkSource::GeneralPump2(), and NetworkSink::TimedFlush().

bool Waitable::Wait | ( | unsigned long | milliseconds | ) | `[inherited]`

| wait on this object same as creating an empty container, calling GetWaitObjects(), and calling Wait() on the container Definition at line 321 of file wait.cpp. References Waitable::GetWaitObjects(), and WaitObjectContainer::Wait(). Referenced by NetworkSource::GeneralPump2(), and NetworkSink::TimedFlush().

The documentation for this class was generated from the following file:

- winpipes.h